""" Location widget module
"""
from AccessControl import ClassSecurityInfo
from Products.Archetypes.Widget import StringWidget
from Products.Archetypes.Registry import registerWidget

class LocationWidget(StringWidget):
    """ Class which defines the location widget
    """
    _properties = StringWidget._properties.copy()
    _properties.update({
        'macro' : "locationwidget",
        'helper_js': ('locationwidget.js',),
        })

    security = ClassSecurityInfo()

    security.declarePublic('process_form')
    def process_form(self, instance, field, form, empty_marker=None,
                     emptyReturnsMarker=False, validating=True):
        """ Basic impl for form processing in a widget
        """
        value = form.get('address', empty_marker)
        if value is empty_marker:
            return empty_marker
        if emptyReturnsMarker and value == '':
            return empty_marker
        return value, {}

registerWidget(
       LocationWidget,
       title='Sortable MultiSelectionWidget',
       description=('You have the posibility to sort the values you choose.'),
       used_for=('Products.Archetypes.Field.LinesField',))
